/*
 *	copy record
 *
 *	Author: David L. Markowitz (dav@gtc.com)
 */

#include "tapecv.h"

copy_record(from, to)
struct td from, to;
{
	int i;
	int bytes_read = 0;
	int bytes_written = 0;
	char *cp;

	bytes_read = read_block(from);

	if (bytes_read == 0)
		return(1);
	else if (to.cartridge  &&  ((bytes_read % 512) != 0)) {
		cp = response + bytes_read;
		while ((bytes_read%512) != 0) {
			*cp++ = 0;
			bytes_read++;
		}
	}

	if (to.local) {
		if ((bytes_written = write(to.fd, response, bytes_read))
						< bytes_read) {
			perror("Write failed");
			exit(-1);
		}
	}
	else {
		sprintf(cmd, "W%d\n", bytes_read);
		write(to.fd, cmd, strlen(cmd));
		write(to.fd, response, bytes_read);
		read(to.fd, response, 1);
		if (response[0] == 'A') {
			fdgets(to.fd, response);
			bytes_written = atoi(response);
		}
		else {
			fprintf(stderr, "response was %c\n", response[0]);
			fdgets(to.fd, response);	/* Error number */
			fprintf(stderr,
			"copy_record: write(to) failed: Error number %s\n",
						response);
			fdgets(to.fd, response);	/* Error msg */
			fprintf(stderr, "%s", response);
			exit(-1);
		}
	}

	if (bytes_written != bytes_read) {
	fprintf(stderr, "copy_record: write didn't match read\n");
		fprintf(stderr, "%d read, %d written\n",
			bytes_read, bytes_written);
		exit(-1);
	}

	if (verbose && bytes_read > 0)
		printf("Copied a %d byte record\n", bytes_read);

	return(0);
}
