/*
 *	read block
 *
 *	Author: David L. Markowitz (dav@gtc.com)
 */

#include "tapecv.h"
#include <errno.h>

read_block(from)
struct td from;
{
	int		bytes_read;
	extern int	errno;
	char		errnum[MAXBLK];

	if (from.local) {
		if ((bytes_read = read(from.fd, response, max_block)) < 0) {
			if ((errno == EIO)  &&  from.cartridge) {
				/* Pretend this was EOT */
				return(0);
			}
			perror("read_block: read from local tape failed");
			exit(-1);
		}
	}
	else {
		sprintf(cmd, "R%d\n", max_block);
		write(from.fd, cmd, strlen(cmd));
		read(from.fd, response, 1);
		if (response[0] == 'A') {
			fdgets(from.fd, response);
			bytes_read = atoi(response);
			readsocket(from.fd, response, bytes_read);
		}
		else {
			/* Get the error info */
			fdgets(from.fd, errnum);	/* Error number */
			fdgets(from.fd, response);	/* Error msg */

			if (strcmp(errnum, "5")  &&  from.cartridge) {
				/* Pretend this was EOT */
				return(0);
			}
			fprintf(stderr,
				"read_block: read from remote tape failed: %s",
				response);
			exit(-1);
		}
	}

	return(bytes_read);
}
