/*
 *	Read data from a socket, handling partial reads.
 *
 *	Author: David L. Markowitz (dav@gtc.com)
 */

#include "tapecv.h"

readsocket(fd, buffer, bytes)
int fd;
char *buffer;
int bytes;
{
	int i;

	while ((i = read(fd, buffer, bytes)) < bytes) {
		if (i < 0) {
			perror("readsocket - Read from socket failed");
			exit(-1);
		}
		if (i == 0) {
			fprintf(stderr, "readsocket - EOF on socket\n");
			exit(-1);
		}
		bytes -= i;
		buffer += i;
	}
}
