/*
 *	rewind_tapes
 *
 *	Author: David L. Markowitz (dav@gtc.com)
 */

#include "tapecv.h"
#include <sys/types.h>
#include <sys/ioctl.h>
#include <sys/mtio.h>

rewind_tapes(from, to)
struct td from, to;
{
	rewind_tape(from);
	rewind_tape(to);
}

rewind_tape(tape)
struct td tape;
{
	struct mtop mtop;

	/* rewind this tape */
	if (tape.local) {
		mtop.mt_op = MTREW;
		mtop.mt_count = 1;
		ioctl(tape.fd, MTIOCTOP, &mtop);
	}
	else {
		sprintf(cmd, "I%d\n1\n", MTREW);
		if (write(tape.fd, cmd, strlen(cmd)) < 0)
			perror("rewind_tapes - write(tape) failed");
		read(tape.fd, response, 1);
		if (response[0] != 'A') {
			fdgets(tape.fd, response);	/* Error number */
			fdgets(tape.fd, response);	/* Error msg */
			fprintf(stderr, "rewind_tapes: ioctl failed: %s",
							response);
			exit(-1);
		}
		fdgets(tape.fd, response);	/* discard this junk */
	}

	return;
}
