/*
 *	verify file
 *
 *	Author: David L. Markowitz (dav@gtc.com)
 */

#include "tapecv.h"

verify_file(from, to)
struct td from, to;
{
	int real_block;

	records_verified = 0;
	if (boot_tape  &&  files_verified != 0) {
		/* Assume a boot tape's special format (Argh!) */
		real_block = max_block;
		max_block = 512;
		if (verify_record(from, to)) {
			max_block = real_block;
			goto eof;
		}
		max_block = real_block;
		records_verified++;
	}

	for (; ; records_verified++)
		if (verify_record(from, to))
			break;

	if (verbose  &&  records_verified > 0)
		printf("Verified file %d: %d records\n",
			files_verified+1, records_verified);

eof:
	if (records_verified > 0)
		return(0);	/* Not EOF */
	else
		return(1);	/* Empty file ::= EOT */
}
