/*
 *	verify record
 *
 *	Author: David L. Markowitz (dav@gtc.com)
 */

#include "tapecv.h"
#include <sys/file.h>

verify_record(from, to)
struct td from, to;
{
	int i;
	int bytes_from = 0;
	int bytes_to = 0;
	char *cp;

	bytes_from = read_block(from);
	bcopy(response, data_from, bytes_from);

	bytes_to = read_block(to);
	bcopy(response, data_to, bytes_to);

	if (to.cartridge  &&  ((bytes_from % 512) != 0)) {
		cp = data_from + bytes_from;
		while ((bytes_from%512) != 0) {
			*cp++ = 0;
			bytes_from++;
		}
	}

	if (bytes_from != bytes_to) {
		fprintf(stderr, "verify_record: block sizes didn't match\n");
		fprintf(stderr, "%d on tape read, %d on tape written\n",
						bytes_from, bytes_to);
		exit(-1);
	}

	if (bcmp(data_from, data_to, bytes_from)) {
		fprintf(stderr,
		    "verify_record: data doesn't match on file %d, record %d\n",
		    files_verified+1, records_verified+1);

		i = open("from.data", O_CREAT|O_WRONLY|O_TRUNC, 0666);
		write(i, data_from, bytes_from);
		close(i);

		i = open("to.data", O_CREAT|O_WRONLY|O_TRUNC, 0666);
		write(i, data_to, bytes_from);
		close(i);

		fprintf(stderr, "Records saved in from.data and to.data\n");
		exit(-1);
	}

	if (verbose  &&  bytes_from > 0)
		printf("Verified a %d byte record\n", bytes_from);

	if (bytes_from == 0)
		return(1);	/* EOF */
	else
		return(0);
}
